// Cache management routines

//var cache = Components.classes['@mozilla.org/properties;1'].createInstance(Components.interfaces.nsIProperties);
var cache = new Object();

function getJSDate(gdate) {
	var parts = gdate.split(" ");
	var parts1 = parts[0].split("-");
	var parts2 = parts[1].split(":");
	var d = new Date();
	d.setFullYear(parts1[0]);
	d.setMonth(parts1[1] - 1);
	d.setDate(parts1[2]);
	d.setHours(parts2[0]);
	d.setMinutes(parts2[1]);
	d.setSeconds(parts2[2]);
	return d;
}

function isFresh(expiretime) {
	var expiredate = getJSDate(expiretime);
	var now = new Date();
	if (expiredate < now) {
		return false;
	} else {
		return true;
	}
}

function loadCache() {
//	alert("loading cache");
	var prefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
	var cacheFileName = prefBranch.getCharPref("extensions.geotrust.cachefile");

	// get profile folder
	var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);

	file.append(cacheFileName);
//	alert("file.path: " + file.path);

	if (!file.exists()) {
//		alert("cache file does not exist");
		return;
	}

	var cacheStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);;
	cacheStream.init(file, 0x01, 0444, 0);
//	alert("cacheStream: " + cacheStream);

	var lis = cacheStream.QueryInterface(Components.interfaces.nsILineInputStream);
//	alert("lis: " + lis);
	var cacheLine = {};
	var cont = lis.readLine(cacheLine);
	while (cont) {
//		var line = converter.ConvertToUnicode(cacheLine.value);
		var cacheLineV = cacheLine.value;
//		alert("cacheLineV:" + cacheLineV);
		if (cacheLineV.charAt(0) == '"' && cacheLineV.charAt(cacheLineV.length - 1) == '"') {
			cacheLineV = cacheLineV.substring(1, cacheLineV.length - 1);
		}
		var cacheData = cacheLineV.split("\",\"");
		var cacheEntry = new Object();
		cacheEntry.host = cacheData[0];
		cacheEntry.trustlevel = cacheData[1];
		cacheEntry.expiretime = cacheData[2];
		cacheEntry.partner = cacheData[3];
		if (isFresh(cacheEntry.expiretime)) {
			cache[cacheEntry.host] = cacheEntry;
		}
//		alert("setting cache["+cacheEntry.host+"] = " + cacheEntry + ":" + cacheData);
		cont = lis.readLine(cacheLine);
	}

	cacheStream.close();
}

function saveCache() {
//	alert("saving cache");
	var prefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
	var cacheFileName = prefBranch.getCharPref("extensions.geotrust.cachefile");

	// get profile folder
	var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);

	file.append(cacheFileName);

	var cacheStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);;
	cacheStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0);	// write, create, truncate
//	alert("cacheStream: " + cacheStream);

	for (var i in cache) {
		var str = "\"" + cache[i].host + "\",\"" + cache[i].trustlevel + "\",\"" + cache[i].expiretime + "\",\"" + cache[i].partner + "\"\n";
//		alert("writing: " + str);
		cacheStream.write(str, str.length);
	}

	cacheStream.close();
}

function readFromCache(host) {
	var entry = cache[host];
	if (!entry) {
		return null;
	}
	if (!isFresh(entry.expiretime)) {
		return null;
	}
	
	return entry;
}

function writeToCache(host, trustlevel, expiretime, partner) {
//	alert("writing to cache: host=" + host  + ", trustlevel=" + trustlevel + ", expiretime =" + expiretime + ", partner = " + partner);
	var cacheEntry = new Object();
	cacheEntry.host = host;
	cacheEntry.trustlevel = trustlevel;
	cacheEntry.expiretime = expiretime;
	cacheEntry.partner = partner;
	cache[host] = cacheEntry;
}


window.addEventListener("load", loadCache, false);
window.addEventListener("unload", saveCache, false);
