var prefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
var profile = prefBranch.getCharPref("extensions.geotrust.profile");
var profilePrefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("extensions.geotrust." + profile + ".");

function urlToHost(url) {
	var host = url.replace(/^[a-z]*:\/\//, "").replace(/\/.*$/, "");
	return host;
}

function processUrl(url) {
	if (url.match(/^http:\/\/www.google.[a-z]+\/url\?.*url=/)) {
		var newurl = url.replace(/^.*&url=/, "").replace(/&.*$/, "");
//		alert("converting url (" + url + ") to (" + newurl + ")");
		return decodeURIComponent(newurl);
	} else if (url.match(/^http:\/\/www.google.[a-z]+\/url\?.*q=/)) {
		var newurl = url.replace(/^.*&q=/, "").replace(/&.*$/, "");
//		alert("converting url (" + url + ") to (" + newurl + ")");
		return decodeURIComponent(newurl);
	} else if (url.match(/^http:\/\/www.google.[a-z]+\/pagead\/iclk\?/)) {
		var newurl = url.replace(/^.*&adurl=/, "").replace(/&.*$/, "");
//		alert("converting url (" + url + ") to (" + newurl + ")");
		return decodeURIComponent(newurl);
	} else if (url.match(/^http:\/\/rds.yahoo.[a-z]+\/.*yargs=/)) {
		// Yahoo ads
		var newurl = url.replace(/^.*yargs=/, "");
//		alert("converting Yahoo ad url (" + url + ") to (" + newurl + ")");
		return decodeURIComponent(newurl);
	} else if (url.match(/^http:\/\/rds.yahoo.[a-z]+\/.*\*\*/)) {
		// Yahoo results
		var newurl = url.replace(/^.*\*\*/, "");
//		alert("converting url (" + url + ") to (" + newurl + ")");
		return decodeURIComponent(newurl);
	} else if (url.match(/msn\..*act2.aspx\?.*yargs%3d/)) {
		// MSN ads
		var newurl = url.replace(/^.*yargs%3d/, "").replace(/&&.*/, "");
//		alert("converting url (" + url + ") to (" + newurl + ")");
		return decodeURIComponent(newurl);
	} else if (url.match(/^http:\/\/g.msn.com\/9SE\/1\?/)) {
		// MSN links
		var newurl = url.replace(/^.*\?/, "").replace(/&&.*/, "");
//		alert("converting url (" + url + ") to (" + newurl + ")");
		return decodeURIComponent(newurl);
	} else {
		return url;
	}
}

function geotrustToggleEnabled() {
	var en = prefBranch.getBoolPref("extensions.geotrust.enabled");
	geotrustSetEnabled(!en);
}

function geotrustSetEnabled(en) {
//	alert("setting enabled: " + en);
	prefBranch.setBoolPref("extensions.geotrust.enabled", en);
	updateGeotrustStatus();
}

// do not put alerts in this function (can't lose window focus)
function updateGeotrustStatus() {
	var icon = document.getElementById('geotrust-status');
	var menuitem = document.getElementById('geotrust-enabled-menuitem');

	if (icon && menuitem) {
		var enabled = prefBranch.getBoolPref("extensions.geotrust.enabled");
		if (enabled) {
			icon.src = "chrome://geotrust/content/statusicon-enabled.png";
			menuitem.setAttribute('checked', 'true');
		} else {
			icon.src = "chrome://geotrust/content/statusicon-disabled.png";
			menuitem.setAttribute('checked', 'false');
		}
	}
}

function geotrustSettings() {
	window.openDialog("chrome://geotrust/content/geotrustSettings.xul", "_blank", "chrome,resizable,centerscreen");
}

function geotrustAbout() {
	window.openDialog("chrome://geotrust/content/about.xul", "_blank", "chrome,resizable,centerscreen");
}

function reportFraud(url) {
//	var url = getBrowser().contentWindow.location.href;
	var host = urlToHost(url);
	window.open("http://profile.trustwatch.com/twprofile/reportfs?dns=" + host + "&url=" + encodeURIComponent(url) + "&client=twffso0.2.4&id=12345789", "trustwindow", "toolbar=0,scrollbars=0,location=0,statusbar=1,menubar=0,resizable=1,width=515,height=565,left=457.5,top=252.5");
}

function geoContextPopupShowing() {
	gContextMenu.showItem("geotrust-report-link", gContextMenu.onLink && gContextMenu.linkProtocol != "javascript");
}
