var GeoTrustSettings = {

	onLoad: function() {
//		alert("in onLoad()");
		// Setup object properties
		this.prefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);

		this.enabledField = document.getElementById('enabled');
		this.googleEnabledField = document.getElementById('enabled-google');
		this.msnEnabledField = document.getElementById('enabled-msn');
		this.yahooEnabledField = document.getElementById('enabled-yahoo');
		this.profileField = document.getElementById('profile');
		this.vsimgField = document.getElementById('verified_secure_image_url');
		this.vstxtField = document.getElementById('verified_secure_text');
		this.vimgField = document.getElementById('verified_image_url');
		this.vtxtField = document.getElementById('verified_text');
		this.nvimgField = document.getElementById('not_verified_image_url');
		this.nvtxtField = document.getElementById('not_verified_text');
		this.wimgField = document.getElementById('warning_image_url');
		this.wtxtField = document.getElementById('warning_text');
		this.workimgField = document.getElementById('working_image_url');
		this.srimgField = document.getElementById('site_report_image_url');
		this.iwField = document.getElementById('icon_width');

		this.loadFields();
	},

	loadFields: function() {
//		alert("in loadFields()");
		this.enabledField.setAttribute('checked', this.prefBranch.getBoolPref('extensions.geotrust.enabled'));
		this.googleEnabledField.setAttribute('checked', this.prefBranch.getBoolPref('extensions.geotrust.enabled-google'));
		this.msnEnabledField.setAttribute('checked', this.prefBranch.getBoolPref('extensions.geotrust.enabled-msn'));
		this.yahooEnabledField.setAttribute('checked', this.prefBranch.getBoolPref('extensions.geotrust.enabled-yahoo'));

		var profile = null;
		try {
			profile = this.prefBranch.getCharPref('extensions.geotrust.profile');
			this.profilePrefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("extensions.geotrust." + profile + ".");
		} catch (err) {}
		if (profile) {
//			this.profileField.value = profile;
			if (profile == "default") {
				this.profileField.selectedIndex = 0;
			} else if (profile == "bigicons") {
				this.profileField.selectedIndex = 1;
			}

			var notCustom = true;
			if (profile == "custom") {
				notCustom = false;
			}
			this.vsimgField.disabled = notCustom;
			this.vstxtField.disabled = notCustom;
			this.vimgField.disabled = notCustom;
			this.vtxtField.disabled = notCustom;
			this.nvimgField.disabled = notCustom;
			this.nvtxtField.disabled = notCustom;
			this.wimgField.disabled = notCustom;
			this.wtxtField.disabled = notCustom;
			this.workimgField.disabled = notCustom;
			this.srimgField.disabled = notCustom;
			this.iwField.disabled = notCustom;
		}
		var vsimg = null;
		try {
			vsimg = this.profilePrefBranch.getCharPref('verified_secure_image_url');
		} catch (err) {}
		if (vsimg) {
			this.vsimgField.value = vsimg;
		}
		var vstext = null;
		try {
			vstext = this.profilePrefBranch.getCharPref('verified_secure_text');
		} catch (err) {}
		if (vstext) {
			this.vstxtField.value = vstext;
		}

		var vimg = null;
		try {
			vimg = this.profilePrefBranch.getCharPref('verified_image_url');
		} catch (err) {}
		if (vimg) {
			this.vimgField.value = vimg;
		}
		var vtext = null;
		try {
			vtext = this.profilePrefBranch.getCharPref('verified_text');
		} catch (err) {}
		if (vtext) {
			this.vtxtField.value = vtext;
		}

		var nvimg = null;
		try {
			nvimg = this.profilePrefBranch.getCharPref('not_verified_image_url');
		} catch (err) {}
		if (nvimg) {
			this.nvimgField.value = nvimg;
		}
		var nvtext = null;
		try {
			nvtext = this.profilePrefBranch.getCharPref('not_verified_text');
		} catch (err) {}
		if (nvtext) {
			this.nvtxtField.value = nvtext;
		}

		var wimg = null;
		try {
			wimg = this.profilePrefBranch.getCharPref('warning_image_url');
		} catch (err) {}
		if (wimg) {
			this.wimgField.value = wimg;
		}
		var wtext = null;
		try {
			wtext = this.profilePrefBranch.getCharPref('warning_text');
		} catch (err) {}
		if (wtext) {
			this.wtxtField.value = wtext;
		}

		var workimg = null;
		try {
			workimg = this.profilePrefBranch.getCharPref('working_image_url');
		} catch (err) {}
		if (workimg) {
			this.workimgField.value = workimg;
		}

		var srimg = null;
		try {
			srimg = this.profilePrefBranch.getCharPref('site_report_image_url');
		} catch (err) {}
		if (srimg) {
			this.srimgField.value = srimg;
		}

		var iw = null;
		try {
			iw = this.profilePrefBranch.getCharPref('icon_width');
		} catch (err) {}
		if (iw) {
			this.iwField.value = iw;
		}

		sizeToContent();
	},
	
	onAccept: function() {
//		alert("in onAccept()");
		this.prefBranch.setBoolPref('extensions.geotrust.enabled', this.enabledField.checked);
		this.prefBranch.setBoolPref('extensions.geotrust.enabled-google', this.googleEnabledField.checked);
		this.prefBranch.setBoolPref('extensions.geotrust.enabled-msn', this.msnEnabledField.checked);
		this.prefBranch.setBoolPref('extensions.geotrust.enabled-yahoo', this.yahooEnabledField.checked);

		var vsimg = this.trimString(this.vsimgField.value);
		if (vsimg) {
			this.profilePrefBranch.setCharPref('verified_secure_image_url', vsimg);
		}
		var vstxt = this.trimString(this.vstxtField.value);
		if (vstxt) {
			this.profilePrefBranch.setCharPref('verified_secure_text', vstxt);
		}

		var vimg = this.trimString(this.vimgField.value);
		if (vimg) {
			this.profilePrefBranch.setCharPref('verified_image_url', vimg);
		}
		var vtxt = this.trimString(this.vtxtField.value);
		if (vtxt) {
			this.profilePrefBranch.setCharPref('verified_text', vtxt);
		}

		var nvimg = this.trimString(this.nvimgField.value);
		if (nvimg) {
			this.profilePrefBranch.setCharPref('not_verified_image_url', nvimg);
		}
		var nvtxt = this.trimString(this.nvtxtField.value);
		if (nvtxt) {
			this.profilePrefBranch.setCharPref('not_verified_text', nvtxt);
		}

		var wimg = this.trimString(this.wimgField.value);
		if (wimg) {
			this.profilePrefBranch.setCharPref('warning_image_url', wimg);
		}
		var wtxt = this.trimString(this.wtxtField.value);
		if (wtxt) {
			this.profilePrefBranch.setCharPref('warning_text', wtxt);
		}

		var workimg = this.trimString(this.workimgField.value);
		if (workimg) {
			this.profilePrefBranch.setCharPref('working_image_url', workimg);
		}

		var srimg = this.trimString(this.srimgField.value);
		if (srimg) {
			this.profilePrefBranch.setCharPref('site_report_image_url', srimg);
		}

		var iw = this.trimString(this.iwField.value);
		if (iw) {
			this.profilePrefBranch.setCharPref('icon_width', iw);
		}
	},

	setProfile: function(p) {
//		alert("in setProfile()");
		this.prefBranch.setCharPref('extensions.geotrust.profile', p);
		this.loadFields();
	},

	trimString: function(string) {
		return string.replace(/(^\s+)|(\s+$)/g, '');
	}
};
