// ==UserScript==
// @name            TrustWatch Search by GeoTrust
// @namespace       http://www.trustwatch.com
// @description     TrustWatch Search Results
// @include         http://www.google.*/search*
// ==/UserScript==

var transpixel = "data:image/gif,GIF89a%01%00%01%00%80%00%00%00%00%00%FF%FF%FF!%F9%04%01%00%00%00%00%2C%00%00%00%00%01%00%01%00%40%02%01D%00%3B";

var prefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
var profile = prefBranch.getCharPref("extensions.geotrust.profile");
var profilePrefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("extensions.geotrust." + profile + ".");
var adPrefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("extensions.geotrust.ad.");

function convertGeotrustIncrDate(date) {
	var parts = date.split("-");
	var d = new Date();
	d.setDate(d.getDate() + parseInt(parts[0]));
	d.setHours(d.getHours() + parseInt(parts[1]));
	d.setMinutes(d.getMinutes() + parseInt(parts[2]));
	d.setSeconds(d.getSeconds() + parseInt(parts[3]));

	var dateStr = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds();
//	alert("converted " + date + " to " + dateStr + " using parts: " + parts + " (current = " + new Date() + ")");
	return dateStr;
}

function updateSearchResult(doc, id, textid, srid, frid, url, host, trustlevel, context) {
		var trustinfo = doc.getElementById(id);
		var trustlink = trustinfo.firstChild;
		trustlink.href = "javascript:void window.open('http://profile.trustwatch.com/twprofile/profile?dns=" + host + "&url=" + encodeURIComponent(url) + "&v=1', 'trustwindow', 'toolbar=0,scrollbars=0,location=0,statusbar=1,menubar=0,resizable=1,width=515,height=565,left = 457.5,top = 252.5')";
		var trustimage = trustlink.firstChild;
//		trustimage.alt = "trustlevel=" + trustlevel;

		var trusttext = doc.getElementById(textid).firstChild;
//		alert("trusttext("+textid+"):" + trusttext);
		var sitereportlink = doc.getElementById(srid);
		var fraudreportlink = doc.getElementById(frid);
		sitereportlink.href = "javascript:void window.open('http://profile.trustwatch.com/twprofile/profile?dns=" + host + "&url=" + encodeURIComponent(url) + "&v=1', 'trustwindow', 'toolbar=0,scrollbars=0,location=0,statusbar=1,menubar=0,resizable=1,width=515,height=565,left = 457.5,top = 252.5')";
		fraudreportlink.href= "javascript:void window.open('http://profile.trustwatch.com/twprofile/reportfs?dns=" + host + "&url=" + encodeURIComponent(url) + "&client=twffso0.2.4&id=12345789', 'trustwindow', 'toolbar=0,scrollbars=0,location=0,statusbar=1,menubar=0,resizable=1,width=515,height=565,left = 457.5,top = 252.5')";

		var contextPrefBranch;
		if (context == "ad") {
			contextPrefBranch = adPrefBranch;
		} else {
			contextPrefBranch = profilePrefBranch;
		}

		if (trustlevel >= 1.1 && trustlevel < 99.0) {
			trustimage.src = contextPrefBranch.getCharPref('verified_secure_image_url');
			trusttext.nodeValue = decodeURI(contextPrefBranch.getCharPref('verified_secure_text'));
		} else if (trustlevel >= 0.5 && trustlevel < 1.1) {
			trustimage.src = contextPrefBranch.getCharPref('verified_image_url');
			trusttext.nodeValue = decodeURI(contextPrefBranch.getCharPref('verified_text'));
		} else if (trustlevel >= 0.0 && trustlevel < 0.5) {
			trustimage.src = contextPrefBranch.getCharPref('not_verified_image_url');
			trusttext.nodeValue = decodeURI(contextPrefBranch.getCharPref('not_verified_text'));
		} else if (trustlevel >= -98.0 && trustlevel < 0.0) {
			trustimage.src = contextPrefBranch.getCharPref('warning_image_url');
			trusttext.nodeValue = decodeURI(contextPrefBranch.getCharPref('warning_text'));
		}
}

function updateTrustInfo(e, id, textid, srid, frid, url, context) {
	var trustquery = 'http://www.trustwatch.com/twsearch/servlet/RequestTL?client=twie2.0&id=123456789&dns=';
	var timeoutid;
	var cacheResult;

	if (cacheResult = readFromCache(urlToHost(url))) {
		updateSearchResult(e.originalTarget, id, textid, srid, frid, url, cacheResult.host, cacheResult.trustlevel, context);
	} else {
		var xmlhttp = new XMLHttpRequest();
		xmlhttp.onload = function(response) {
			window.clearTimeout(timeoutid);

			var page = response.target.responseText;
//			alert("page: " + page);
			var trustlevel = page.match(/<trustlevel>(-?[0-9\.]*)<\/trustlevel>/)[1];
			var host = page.match(/<host>(.*)<\/host>/)[1];
			var partner = page.match(/<partner>(.*)<\/partner>/)[1];
			var expiretime = page.match(/<expiretime>(.*)<\/expiretime>/)[1];
//			alert("updateTrustInfo: url=" + url + ", host=" + urlToHost(url) + ", host=" + host);

			updateSearchResult(e.originalTarget, id, textid, srid, frid, url, host, trustlevel, context);

			writeToCache(host, trustlevel, convertGeotrustIncrDate(expiretime), partner);
		};
		xmlhttp.open("GET", trustquery + url, true);
		xmlhttp.send(null);

		timeoutid = window.setTimeout(
			function() {
				xmlhttp.abort();

				var trustinfo = e.originalTarget.getElementById(id);
				trustinfo.firstChild.firstChild.src = transpixel;

				var trusttext = e.originalTarget.getElementById(textid);
				var sitereportfont = trusttext.firstChild;
				sitereportfont.appendChild(e.originalTarget.createTextNode('TrustWatch Timeout'));
			}, prefBranch.getIntPref("extensions.geotrust.timeout"));
	}
}


function do_geotrust_google(e) {
	// Find Google search results
	var results = e.originalTarget.evaluate("//p[@class='g']/a[1]", e.originalTarget, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

	for (var i = 0; i < results.snapshotLength; ++i) {
		var resultlink = results.snapshotItem(i);
		var resultp = resultlink.parentNode;
		var resultparent = resultp.parentNode;

		var url = processUrl(resultlink.href);

		// build trustwatch info td
		var trustinfo = e.originalTarget.createElement("td");
		trustinfo.setAttribute("style", "padding: 0px; vertical-align:top;");
		trustinfo.style.width = profilePrefBranch.getCharPref('icon_width');
		trustinfo.setAttribute("id", "trust" + i);
		var trustlink = e.originalTarget.createElement("a");
		var trustimage = e.originalTarget.createElement("img");
		trustimage.setAttribute("style", "border:0px; vertical-align:middle;");
		trustimage.src = profilePrefBranch.getCharPref('working_image_url');
		trustlink.appendChild(trustimage);
		trustinfo.appendChild(trustlink);

		// build trustwatch site report text span
		var trusttext = e.originalTarget.createElement("span");
		trusttext.setAttribute("style", "color:#666666;");
		var sitereportfont = e.originalTarget.createElement("font");
		sitereportfont.setAttribute("size", "-1");
		sitereportfont.setAttribute("id", "trusttext" + i);
		var text = e.originalTarget.createTextNode('');
		sitereportfont.appendChild(text);
		trusttext.appendChild(sitereportfont);
		var sitereportlink = e.originalTarget.createElement("a");
		sitereportlink.setAttribute("id", "trustsr" + i);
		var fraudreportlink = e.originalTarget.createElement("a");
		fraudreportlink.setAttribute("id", "trustfr" + i);
		var sitereportimage = e.originalTarget.createElement("img");
		var fraudreportimage = e.originalTarget.createElement("img");
		sitereportimage.setAttribute("style", "border:0px solid; margin-left:10px; vertical-align:middle;");
		fraudreportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		sitereportimage.src = profilePrefBranch.getCharPref('site_report_image_url');
		fraudreportimage.src = profilePrefBranch.getCharPref('fraud_report_image_url');
		sitereportlink.appendChild(sitereportimage);
		fraudreportlink.appendChild(fraudreportimage);
		trusttext.appendChild(sitereportlink);
		trusttext.appendChild(fraudreportlink);

		// wrap search result in a td
		var resultptd = e.originalTarget.createElement("td");
		resultptd.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px; vertical-align:top;");
		resultparent.insertBefore(resultptd, resultp);
		resultptd.appendChild(resultp);

		// a tr to wrap the trustinfo and search result tds
		var resulttr = e.originalTarget.createElement("tr");
		resultparent.insertBefore(resulttr, resultptd);
		resulttr.appendChild(trustinfo);
		resulttr.appendChild(resultptd);

		var row2 = e.originalTarget.createElement("tr");
		var row2col1 = e.originalTarget.createElement("td");
		row2col1.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px;");
		var row2col2 = e.originalTarget.createElement("td");
		row2col2.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px;");
		row2col2.appendChild(trusttext);
		row2.appendChild(row2col1);
		row2.appendChild(row2col2);

		var resulttable = e.originalTarget.createElement("table");
		resulttable.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 5px 0px; margin: 0.5em 0;");
		resultparent.insertBefore(resulttable, resulttr);
		resulttable.appendChild(resulttr);
		resulttable.appendChild(row2);

		// remove margins from <p>
		resultp.style.marginTop = "0pt";
		resultp.style.marginBottom = "0pt";

		updateTrustInfo(e, "trust" + i, "trusttext" + i, "trustsr" + i, "trustfr" + i, url, "result");
	}

	// remove blockquote margins
	var bqs = e.originalTarget.evaluate("//blockquote[@class='g']", e.originalTarget, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

	for (var i = 0; i < bqs.snapshotLength; ++i) {
		var bq = bqs.snapshotItem(i);
//		alert("remove margins from bq: " + bq);
		bq.style.marginTop = "0pt";
		bq.style.marginBottom = "0pt";
	}

	// right-side ad links
	var ads = e.originalTarget.evaluate("//table[@align='right'][@width='25%'][@border='0']//a[starts-with(@id, 'aw')]", e.originalTarget, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

	for (var i = 0; i < ads.snapshotLength; ++i) {
		var resultlink = ads.snapshotItem(i);
		var resultparent = resultlink.parentNode;

		var url = processUrl(resultlink.href);

		// build trustwatch info td
		var trustinfo = e.originalTarget.createElement("td");
		trustinfo.setAttribute("style", "padding: 0px 3px 0px 0px; vertical-align:top;");
		trustinfo.style.width = adPrefBranch.getCharPref('icon_width');
		trustinfo.setAttribute("id", "trustad" + i);
		var trustlink = e.originalTarget.createElement("a");
		var trustimage = e.originalTarget.createElement("img");
		trustimage.setAttribute("style", "border:0px; vertical-align:middle;");
		trustimage.src = adPrefBranch.getCharPref('working_image_url');
		trustlink.appendChild(trustimage);
		trustinfo.appendChild(trustlink);

		// build trustwatch site report text span
		var trusttext = e.originalTarget.createElement("span");
		trusttext.setAttribute("style", "color:#666666;");
		var sitereportfont = e.originalTarget.createElement("font");
		sitereportfont.setAttribute("size", "-1");
		sitereportfont.setAttribute("id", "trustadtext" + i);
		var text = e.originalTarget.createTextNode('');
		sitereportfont.appendChild(text);
		trusttext.appendChild(sitereportfont);
		var sitereportlink = e.originalTarget.createElement("a");
		sitereportlink.setAttribute("id", "trustadsr" + i);
		var fraudreportlink = e.originalTarget.createElement("a");
		fraudreportlink.setAttribute("id", "trustadfr" + i);
		var sitereportimage = e.originalTarget.createElement("img");
		var fraudreportimage = e.originalTarget.createElement("img");
		sitereportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		fraudreportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		sitereportimage.src = adPrefBranch.getCharPref('site_report_image_url');
		fraudreportimage.src = adPrefBranch.getCharPref('fraud_report_image_url');
		sitereportlink.appendChild(sitereportimage);
		fraudreportlink.appendChild(fraudreportimage);
		trusttext.appendChild(sitereportlink);
		trusttext.appendChild(fraudreportlink);

		// wrap ad result in a td
		var resulttd = e.originalTarget.createElement("td");
		resulttd.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px; vertical-align:top;");
		var resulttdfont = e.originalTarget.createElement("font");
		resulttd.appendChild(resulttdfont);
		resulttdfont.setAttribute("size", "-1");
		resultparent.insertBefore(resulttd, resultlink);
		var tempnode = resultlink.nextSibling;
		resulttdfont.appendChild(resultlink);
		while (tempnode && tempnode.nodeName != "A") {
			var tempnode2 = tempnode;
			tempnode = tempnode.nextSibling;
			resulttdfont.appendChild(tempnode2);
		}
		resulttdfont.removeChild(resulttdfont.childNodes[resulttdfont.childNodes.length - 1]);	// remove last BR

		// a tr to wrap the trustinfo and search result tds
		var resulttr = e.originalTarget.createElement("tr");
		resultparent.insertBefore(resulttr, resulttd);
		resulttr.appendChild(trustinfo);
		resulttr.appendChild(resulttd);

		var row2 = e.originalTarget.createElement("tr");
		var row2col1 = e.originalTarget.createElement("td");
		row2col1.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px;");
		var row2col2 = e.originalTarget.createElement("td");
		row2col2.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px;");
		row2col2.appendChild(trusttext);
		row2.appendChild(row2col1);
		row2.appendChild(row2col2);

		var resulttable = e.originalTarget.createElement("table");
		resulttable.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px 0px; margin: 0.5em 0;");
		resultparent.insertBefore(resulttable, resulttr);
		resulttable.appendChild(resulttr);
		resulttable.appendChild(row2);

		updateTrustInfo(e, "trustad" + i, "trustadtext" + i, "trustadsr" + i, "trustadfr" + i, url, "ad");
	}


	// Top ad links
	var ads = e.originalTarget.evaluate("//div[starts-with(@id, 'tpa')]/a[starts-with(@id, 'pa')]", e.originalTarget, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

	for (var i = 0; i < ads.snapshotLength; ++i) {
		var resultlink = ads.snapshotItem(i);
		var resultdiv = resultlink.parentNode;

		// disable onclick on the div (privileged call)
		resultdiv.wrappedJSObject.onclick = null;

		var url = processUrl(resultlink.href);

		// build trustwatch info td
		var trustinfo = e.originalTarget.createElement("td");
		trustinfo.setAttribute("style", "padding: 0px; vertical-align:top;");
		trustinfo.style.width = adPrefBranch.getCharPref('icon_width');
		trustinfo.setAttribute("id", "trusttopad" + i);
		var trustlink = e.originalTarget.createElement("a");
		var trustimage = e.originalTarget.createElement("img");
		trustimage.setAttribute("style", "border:0px; vertical-align:middle;");
		trustimage.src = adPrefBranch.getCharPref('working_image_url');
		trustlink.appendChild(trustimage);
		trustinfo.appendChild(trustlink);

		// build trustwatch site report text span
		var trusttext = e.originalTarget.createElement("span");
		trusttext.setAttribute("style", "color:#666666;");
		var sitereportfont = e.originalTarget.createElement("font");
		sitereportfont.setAttribute("size", "-1");
		sitereportfont.setAttribute("id", "trusttopadtext" + i);
		var text = e.originalTarget.createTextNode('');
		sitereportfont.appendChild(text);
		trusttext.appendChild(sitereportfont);
		var sitereportlink = e.originalTarget.createElement("a");
		sitereportlink.setAttribute("id", "trusttopadsr" + i);
		var fraudreportlink = e.originalTarget.createElement("a");
		fraudreportlink.setAttribute("id", "trusttopadfr" + i);
		var sitereportimage = e.originalTarget.createElement("img");
		var fraudreportimage = e.originalTarget.createElement("img");
		sitereportimage.setAttribute("style", "border:0px solid; margin-left:10px; vertical-align:middle;");
		fraudreportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		sitereportimage.src = adPrefBranch.getCharPref('site_report_image_url');
		fraudreportimage.src = adPrefBranch.getCharPref('fraud_report_image_url');
		sitereportlink.appendChild(sitereportimage);
		fraudreportlink.appendChild(fraudreportimage);
		trusttext.appendChild(sitereportlink);
		trusttext.appendChild(fraudreportlink);

		// wrap search result in a td
		var resulttd = e.originalTarget.createElement("td");
		resulttd.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px; vertical-align:top;");
		resultdiv.insertBefore(resulttd, resultdiv.firstChild);
		while (resulttd.nextSibling) {
			resulttd.appendChild(resulttd.nextSibling);
		}

		// a tr to wrap the trustinfo and search result tds
		var resulttr = e.originalTarget.createElement("tr");
		resultdiv.insertBefore(resulttr, resulttd);
		resulttr.appendChild(trustinfo);
		resulttr.appendChild(resulttd);

		var row2 = e.originalTarget.createElement("tr");
		var row2col1 = e.originalTarget.createElement("td");
		row2col1.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px;");
		var row2col2 = e.originalTarget.createElement("td");
		row2col2.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px;");
		row2col2.appendChild(trusttext);
		row2.appendChild(row2col1);
		row2.appendChild(row2col2);

		var resulttable = e.originalTarget.createElement("table");
		resulttable.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px 0px; margin: 0px 0px;");
		resultdiv.insertBefore(resulttable, resulttr);
		resulttable.appendChild(resulttr);
		resulttable.appendChild(row2);

		updateTrustInfo(e, "trusttopad" + i, "trusttopadtext" + i, "trusttopadsr" + i, "trusttopadfr" + i, url, "ad");
	}
}


function do_geotrust_yahoo(e) {
	// Find Yahoo search results
	var results = e.originalTarget.evaluate("//a[@class='yschttl']", e.originalTarget, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

	var resultol;
	for (var i = 0; i < results.snapshotLength; ++i) {
		var resultlink = results.snapshotItem(i);
		var resultlinkdiv = resultlink.parentNode;
		var resultli = resultlinkdiv.parentNode;
		resultol = resultli.parentNode;

//		resultli.parentNode.style.listStyleType = "none";

		var url = processUrl(resultlink.href);

		// build trustwatch info div
		var trustinfo = e.originalTarget.createElement("td");
		trustinfo.setAttribute("style", "padding: 0px 3px 0px 0px; vertical-align:top;");
		trustinfo.style.width = adPrefBranch.getCharPref('icon_width');
		trustinfo.setAttribute("id", "trust" + i);
		var trustlink = e.originalTarget.createElement("a");
		var trustimage = e.originalTarget.createElement("img");
		trustimage.setAttribute("style", "border:0px; vertical-align:middle;");
		trustimage.src = profilePrefBranch.getCharPref('working_image_url');
		trustlink.appendChild(trustimage);
		trustinfo.appendChild(trustlink);

		// build trustwatch site report text div
		var trusttext = e.originalTarget.createElement("div");
		trusttext.setAttribute("style", "color:#666666;");
		var sitereportfont = e.originalTarget.createElement("font");
		sitereportfont.setAttribute("size", "-1");
		sitereportfont.setAttribute("id", "trusttext" + i);
		var text = e.originalTarget.createTextNode('');
		sitereportfont.appendChild(text);
		trusttext.appendChild(sitereportfont);
		var sitereportlink = e.originalTarget.createElement("a");
		sitereportlink.setAttribute("id", "trustsr" + i);
		var fraudreportlink = e.originalTarget.createElement("a");
		fraudreportlink.setAttribute("id", "trustfr" + i);
		var sitereportimage = e.originalTarget.createElement("img");
		var fraudreportimage = e.originalTarget.createElement("img");
		sitereportimage.setAttribute("style", "border:0px solid; margin-left:10px; vertical-align:middle;");
		fraudreportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		sitereportimage.src = profilePrefBranch.getCharPref('site_report_image_url');
		fraudreportimage.src = profilePrefBranch.getCharPref('fraud_report_image_url');
		sitereportlink.appendChild(sitereportimage);
		fraudreportlink.appendChild(fraudreportimage);
		trusttext.appendChild(sitereportlink);
		trusttext.appendChild(fraudreportlink);

		resultli.appendChild(trusttext);

		// wrap search result in a td
		var resulttd = e.originalTarget.createElement("td");
		resulttd.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px; vertical-align:top;");
		resultli.insertBefore(resulttd, resultlinkdiv);
		while (resulttd.nextSibling) {
			resulttd.appendChild(resulttd.nextSibling);
		}

		// a tr to wrap the trustinfo and search result tds
		var resulttr = e.originalTarget.createElement("tr");
		resultli.insertBefore(resulttr, resulttd);
		resulttr.appendChild(trustinfo);
		resulttr.appendChild(resulttd);

		var resulttable = e.originalTarget.createElement("table");
		resulttable.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 5px 0px; margin: 0.5em 0;");
		resultli.insertBefore(resulttable, resulttr);
		resulttable.appendChild(resulttr);

		// move search result outside <ol>
		resultol.parentNode.insertBefore(resulttable, resultol);

		updateTrustInfo(e, "trust" + i, "trusttext" + i, "trustsr" + i, "trustfr" + i, url, "result");
	}

	// remove <ol>
	resultol.parentNode.removeChild(resultol);


	// right-side ad links
	var ads = e.originalTarget.evaluate("//div[@id='yschsec']//li[not(@class='yschprom')]/a", e.originalTarget, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

	for (var i = 0; i < ads.snapshotLength; ++i) {
		var resultlink = ads.snapshotItem(i);
		var resultli = resultlink.parentNode;

		var url = processUrl(resultlink.href);

		// build trustwatch info td
		var trustinfo = e.originalTarget.createElement("td");
		trustinfo.setAttribute("style", "padding: 0px 0px 0px 0px; vertical-align:top;");
		trustinfo.style.width = adPrefBranch.getCharPref('icon_width');
		trustinfo.setAttribute("id", "trustad" + i);
		var trustlink = e.originalTarget.createElement("a");
		trustlink.setAttribute("style", "margin-left:0; margin-right:0;");
		var trustimage = e.originalTarget.createElement("img");
		trustimage.setAttribute("style", "border:0px; vertical-align:middle;");
		trustimage.src = adPrefBranch.getCharPref('working_image_url');
		trustlink.appendChild(trustimage);
		trustinfo.appendChild(trustlink);

		// build trustwatch site report text div
		var trusttext = e.originalTarget.createElement("div");
		trusttext.setAttribute("style", "color:#666666;");
		var sitereportfont = e.originalTarget.createElement("font");
		sitereportfont.setAttribute("size", "-1");
		sitereportfont.setAttribute("id", "trustadtext" + i);
		var text = e.originalTarget.createTextNode('');
		sitereportfont.appendChild(text);
		trusttext.appendChild(sitereportfont);
		var sitereportlink = e.originalTarget.createElement("a");
		sitereportlink.setAttribute("id", "trustadsr" + i);
		sitereportlink.setAttribute("style", "display:inline; margin-left:0;");
		var fraudreportlink = e.originalTarget.createElement("a");
		fraudreportlink.setAttribute("id", "trustadfr" + i);
		fraudreportlink.setAttribute("style", "display:inline; margin-left:0;");
		var sitereportimage = e.originalTarget.createElement("img");
		var fraudreportimage = e.originalTarget.createElement("img");
		sitereportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		fraudreportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		sitereportimage.src = adPrefBranch.getCharPref('site_report_image_url');
		fraudreportimage.src = adPrefBranch.getCharPref('fraud_report_image_url');
		sitereportlink.appendChild(sitereportimage);
		fraudreportlink.appendChild(fraudreportimage);
		trusttext.appendChild(sitereportlink);
		trusttext.appendChild(fraudreportlink);

		resultli.appendChild(trusttext);

		// wrap ad result in a td
		var resulttd = e.originalTarget.createElement("td");
		resulttd.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px; vertical-align:top;");
		resultli.insertBefore(resulttd, resultlink);
		while (resulttd.nextSibling) {
			resulttd.appendChild(resulttd.nextSibling);
		}

		// a tr to wrap the trustinfo and ad result tds
		var resulttr = e.originalTarget.createElement("tr");
		resultli.insertBefore(resulttr, resulttd);
		resulttr.appendChild(trustinfo);
		resulttr.appendChild(resulttd);

		var resulttable = e.originalTarget.createElement("table");
		resulttable.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px 0px; margin: 0 0 0 5px;");
		resultli.insertBefore(resulttable, resulttr);
		resulttable.appendChild(resulttr);

		updateTrustInfo(e, "trustad" + i, "trustadtext" + i, "trustadsr" + i, "trustadfr" + i, url, "ad");
	}


	// top/bottom ad links
	var ads = e.originalTarget.evaluate("//div[@class='yschspns']//li//a", e.originalTarget, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

	for (var i = 0; i < ads.snapshotLength; ++i) {
		var resultlink = ads.snapshotItem(i);
		var resultlinkdiv = resultlink.parentNode;
		var resultli = resultlinkdiv.parentNode;

		resultli.style.marginBottom = "0px";
		resultli.parentNode.style.listStyleType = "none";
		resultli.parentNode.style.paddingLeft = "3px";

		var url = processUrl(resultlink.href);

		// build trustwatch info div
		var trustinfo = e.originalTarget.createElement("td");
		trustinfo.setAttribute("style", "padding: 0px 3px 0px 0px; vertical-align:top;");
		trustinfo.style.width = adPrefBranch.getCharPref('icon_width');
		trustinfo.setAttribute("id", "trusttopad" + i);
		var trustlink = e.originalTarget.createElement("a");
		var trustimage = e.originalTarget.createElement("img");
		trustimage.setAttribute("style", "border:0px; vertical-align:middle;");
		trustimage.src = adPrefBranch.getCharPref('working_image_url');
		trustlink.appendChild(trustimage);
		trustinfo.appendChild(trustlink);

		// build trustwatch site report text div
		var trusttext = e.originalTarget.createElement("div");
		trusttext.setAttribute("style", "color:#666666;");
		var sitereportfont = e.originalTarget.createElement("font");
		sitereportfont.setAttribute("size", "-1");
		sitereportfont.setAttribute("id", "trusttopadtext" + i);
		var text = e.originalTarget.createTextNode('');
		sitereportfont.appendChild(text);
		trusttext.appendChild(sitereportfont);
		var sitereportlink = e.originalTarget.createElement("a");
		sitereportlink.setAttribute("id", "trusttopadsr" + i);
		var fraudreportlink = e.originalTarget.createElement("a");
		fraudreportlink.setAttribute("id", "trusttopadfr" + i);
		var sitereportimage = e.originalTarget.createElement("img");
		var fraudreportimage = e.originalTarget.createElement("img");
		sitereportimage.setAttribute("style", "border:0px solid; margin-left:10px; vertical-align:middle;");
		fraudreportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		sitereportimage.src = adPrefBranch.getCharPref('site_report_image_url');
		fraudreportimage.src = adPrefBranch.getCharPref('fraud_report_image_url');
		sitereportlink.appendChild(sitereportimage);
		fraudreportlink.appendChild(fraudreportimage);
		trusttext.appendChild(sitereportlink);
		trusttext.appendChild(fraudreportlink);

		resultli.appendChild(trusttext);

		// wrap search result in a td
		var resulttd = e.originalTarget.createElement("td");
		resulttd.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px; vertical-align:top;");
		resultli.insertBefore(resulttd, resultlinkdiv);
		while (resulttd.nextSibling) {
			resulttd.appendChild(resulttd.nextSibling);
		}

		// a tr to wrap the trustinfo and search result tds
		var resulttr = e.originalTarget.createElement("tr");
		resultli.insertBefore(resulttr, resulttd);
		resulttr.appendChild(trustinfo);
		resulttr.appendChild(resulttd);

		var resulttable = e.originalTarget.createElement("table");
		resulttable.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 5px 0px; margin: 0.5em 0;");
		resultli.insertBefore(resulttable, resulttr);
		resulttable.appendChild(resulttr);

		updateTrustInfo(e, "trusttopad" + i, "trusttopadtext" + i, "trusttopadsr" + i, "trusttopadfr" + i, url, "ad");
	}
}


function do_geotrust_msn(e) {
	// Find MSN search results
	var results = e.originalTarget.evaluate("//div[@id='results']//h3", e.originalTarget, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

	for (var i = 0; i < results.snapshotLength; ++i) {
		var resulth3 = results.snapshotItem(i);
		var resultlink = resulth3.firstChild;
		var resultli = resulth3.parentNode;

		var url = processUrl(resultlink.href);

		// build trustwatch info div
		var trustinfo = e.originalTarget.createElement("td");
		trustinfo.setAttribute("style", "padding: 0px 3px 0px 0px; vertical-align:top;");
		trustinfo.style.width = adPrefBranch.getCharPref('icon_width');
		trustinfo.setAttribute("id", "trust" + i);
		var trustlink = e.originalTarget.createElement("a");
		var trustimage = e.originalTarget.createElement("img");
		trustimage.setAttribute("style", "border:0px; vertical-align:middle;");
		trustimage.src = profilePrefBranch.getCharPref('working_image_url');
		trustlink.appendChild(trustimage);
		trustinfo.appendChild(trustlink);

		// build trustwatch site report text div
		var trusttext = e.originalTarget.createElement("div");
		trusttext.setAttribute("style", "color:#666666;");
		var sitereportfont = e.originalTarget.createElement("font");
		sitereportfont.setAttribute("size", "-1");
		sitereportfont.setAttribute("id", "trusttext" + i);
		var text = e.originalTarget.createTextNode('');
		sitereportfont.appendChild(text);
		trusttext.appendChild(sitereportfont);
		var sitereportlink = e.originalTarget.createElement("a");
		sitereportlink.setAttribute("id", "trustsr" + i);
		var fraudreportlink = e.originalTarget.createElement("a");
		fraudreportlink.setAttribute("id", "trustfr" + i);
		var sitereportimage = e.originalTarget.createElement("img");
		var fraudreportimage = e.originalTarget.createElement("img");
		sitereportimage.setAttribute("style", "border:0px solid; margin-left:10px; vertical-align:middle;");
		fraudreportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		sitereportimage.src = profilePrefBranch.getCharPref('site_report_image_url');
		fraudreportimage.src = profilePrefBranch.getCharPref('fraud_report_image_url');
		sitereportlink.appendChild(sitereportimage);
		fraudreportlink.appendChild(fraudreportimage);
		trusttext.appendChild(sitereportlink);
		trusttext.appendChild(fraudreportlink);

		// wrap search result in a td
		var resulttd = e.originalTarget.createElement("td");
		resulttd.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px; vertical-align:top;");
		resultli.insertBefore(resulttd, resulth3);
		while (resulttd.nextSibling) {
			resulttd.appendChild(resulttd.nextSibling);
		}

		// a tr to wrap the trustinfo and search result tds
		var resulttr = e.originalTarget.createElement("tr");
		resultli.insertBefore(resulttr, resulttd);
		resulttr.appendChild(trustinfo);
		resulttr.appendChild(resulttd);

		var row2 = e.originalTarget.createElement("tr");
		var row2col1 = e.originalTarget.createElement("td");
		row2col1.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px;");
		var row2col2 = e.originalTarget.createElement("td");
		row2col2.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px;");
		row2col2.appendChild(trusttext);
		row2.appendChild(row2col1);
		row2.appendChild(row2col2);

		var resulttable = e.originalTarget.createElement("table");
		resulttable.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 5px 0px; margin: 0.5em 0;");
		resultli.insertBefore(resulttable, resulttr);
		resulttable.appendChild(resulttr);
		resulttable.appendChild(row2);

		updateTrustInfo(e, "trust" + i, "trusttext" + i, "trustsr" + i, "trustfr" + i, url, "result");
	}


	// right-side ad links
	var ads = e.originalTarget.evaluate("//div[@id='ads_rightC']/ul//a", e.originalTarget, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

	for (var i = 0; i < ads.snapshotLength; ++i) {
		var resultlink = ads.snapshotItem(i);
		var resulth3 = resultlink.parentNode;
		var resultli = resulth3.parentNode;
		var resultul = resultli.parentNode;
		var textlink = resulth3.nextSibling.nextSibling.firstChild.nodeValue;

		if (textlink.match(/^www.[a-zA-Z]*$/)) {
			textlink += ".com";
		}

//		var url = processUrl(resultlink.href);
		var url = "http://" + textlink;

		// build trustwatch info td
		var trustinfo = e.originalTarget.createElement("td");
		trustinfo.setAttribute("style", "padding: 0px 3px 0px 0px; vertical-align:top;");
		trustinfo.style.width = adPrefBranch.getCharPref('icon_width');
		trustinfo.setAttribute("id", "trustad" + i);
		var trustlink = e.originalTarget.createElement("a");
		var trustimage = e.originalTarget.createElement("img");
		trustimage.setAttribute("style", "border:0px; vertical-align:middle;");
		trustimage.src = adPrefBranch.getCharPref('working_image_url');
		trustlink.appendChild(trustimage);
		trustinfo.appendChild(trustlink);

		// build trustwatch site report text span
		var trusttext = e.originalTarget.createElement("span");
		trusttext.setAttribute("style", "color:#666666;");
		var sitereportfont = e.originalTarget.createElement("font");
		sitereportfont.setAttribute("size", "-1");
		sitereportfont.setAttribute("id", "trustadtext" + i);
		var text = e.originalTarget.createTextNode('');
		sitereportfont.appendChild(text);
		trusttext.appendChild(sitereportfont);
		var sitereportlink = e.originalTarget.createElement("a");
		sitereportlink.setAttribute("id", "trustadsr" + i);
		var fraudreportlink = e.originalTarget.createElement("a");
		fraudreportlink.setAttribute("id", "trustadfr" + i);
		var sitereportimage = e.originalTarget.createElement("img");
		var fraudreportimage = e.originalTarget.createElement("img");
		sitereportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		fraudreportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		sitereportimage.src = adPrefBranch.getCharPref('site_report_image_url');
		fraudreportimage.src = adPrefBranch.getCharPref('fraud_report_image_url');
		sitereportlink.appendChild(sitereportimage);
		fraudreportlink.appendChild(fraudreportimage);
		trusttext.appendChild(sitereportlink);
		trusttext.appendChild(fraudreportlink);

		// wrap ad result in a td
		var resulttd = e.originalTarget.createElement("td");
		resulttd.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px; vertical-align:top;");
		resultli.insertBefore(resulttd, resulth3);
		while (resulttd.nextSibling) {
			resulttd.appendChild(resulttd.nextSibling);
		}

		// a tr to wrap the trustinfo and search result tds
		var resulttr = e.originalTarget.createElement("tr");
		resultli.insertBefore(resulttr, resulttd);
		resulttr.appendChild(trustinfo);
		resulttr.appendChild(resulttd);

		var row2 = e.originalTarget.createElement("tr");
		var row2col1 = e.originalTarget.createElement("td");
		row2col1.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px;");
		var row2col2 = e.originalTarget.createElement("td");
		row2col2.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px;");
		row2col2.appendChild(trusttext);
		row2.appendChild(row2col1);
		row2.appendChild(row2col2);

		var resulttable = e.originalTarget.createElement("table");
		resulttable.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px 0px; margin: 0.5em 0;");
		resultli.insertBefore(resulttable, resulttr);
		resulttable.appendChild(resulttr);
		resulttable.appendChild(row2);

		// remove top margin on h3
		resulth3.style.marginTop = "0";

		updateTrustInfo(e, "trustad" + i, "trustadtext" + i, "trustadsr" + i, "trustadfr" + i, url, "ad");
	}


	// top ad links
	var ads = e.originalTarget.evaluate("//div[@id='ads_topC']/ul//a", e.originalTarget, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

	for (var i = 0; i < ads.snapshotLength; ++i) {
		var resultlink = ads.snapshotItem(i);
		var resulth3 = resultlink.parentNode;
		var resultli = resulth3.parentNode;
		var resultul = resultli.parentNode;
		var textlink = resultlink.nextSibling.firstChild.nodeValue.replace(/^.* /, "");

//		var url = processUrl(resultlink.href);
		var url = "http://" + textlink;

		// build trustwatch info td
		var trustinfo = e.originalTarget.createElement("td");
		trustinfo.setAttribute("style", "padding: 0px 3px 0px 0px; vertical-align:top;");
		trustinfo.style.width = adPrefBranch.getCharPref('icon_width');
		trustinfo.setAttribute("id", "trusttopad" + i);
		var trustlink = e.originalTarget.createElement("a");
		var trustimage = e.originalTarget.createElement("img");
		trustimage.setAttribute("style", "border:0px; vertical-align:middle;");
		trustimage.src = adPrefBranch.getCharPref('working_image_url');
		trustlink.appendChild(trustimage);
		trustinfo.appendChild(trustlink);

		// build trustwatch site report text span
		var trusttext = e.originalTarget.createElement("span");
		trusttext.setAttribute("style", "color:#666666;");
		var sitereportfont = e.originalTarget.createElement("font");
		sitereportfont.setAttribute("size", "-1");
		sitereportfont.setAttribute("id", "trusttopadtext" + i);
		var text = e.originalTarget.createTextNode('');
		sitereportfont.appendChild(text);
		trusttext.appendChild(sitereportfont);
		var sitereportlink = e.originalTarget.createElement("a");
		sitereportlink.setAttribute("id", "trusttopadsr" + i);
		var fraudreportlink = e.originalTarget.createElement("a");
		fraudreportlink.setAttribute("id", "trusttopadfr" + i);
		var sitereportimage = e.originalTarget.createElement("img");
		var fraudreportimage = e.originalTarget.createElement("img");
		sitereportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		fraudreportimage.setAttribute("style", "border:0px solid; margin-left:5px; vertical-align:middle;");
		sitereportimage.src = adPrefBranch.getCharPref('site_report_image_url');
		fraudreportimage.src = adPrefBranch.getCharPref('fraud_report_image_url');
		sitereportlink.appendChild(sitereportimage);
		fraudreportlink.appendChild(fraudreportimage);
		trusttext.appendChild(sitereportlink);
		trusttext.appendChild(fraudreportlink);

		// wrap ad result in a td
		var resulttd = e.originalTarget.createElement("td");
		resulttd.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px; vertical-align:top;");
		resultli.insertBefore(resulttd, resulth3);
		while (resulttd.nextSibling) {
			resulttd.appendChild(resulttd.nextSibling);
		}

		// a tr to wrap the trustinfo and search result tds
		var resulttr = e.originalTarget.createElement("tr");
		resultli.insertBefore(resulttr, resulttd);
		resulttr.appendChild(trustinfo);
		resulttr.appendChild(resulttd);

		var row2 = e.originalTarget.createElement("tr");
		var row2col1 = e.originalTarget.createElement("td");
		row2col1.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px;");
		var row2col2 = e.originalTarget.createElement("td");
		row2col2.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px;");
		row2col2.appendChild(trusttext);
		row2.appendChild(row2col1);
		row2.appendChild(row2col2);

		var resulttable = e.originalTarget.createElement("table");
		resulttable.setAttribute("style", "border: 0px solid; padding: 0px; border-spacing: 0px 0px; margin: 0.5em 0;");
		resultli.insertBefore(resulttable, resulttr);
		resulttable.appendChild(resulttr);
		resulttable.appendChild(row2);

		// remove top margin on h3
		resulth3.style.marginTop = "0";

		updateTrustInfo(e, "trusttopad" + i, "trusttopadtext" + i, "trusttopadsr" + i, "trusttopadfr" + i, url, "ad");
	}

	// remove bindAdHandler(el) function
	newBAH = e.originalTarget.createElement("script");
	newBAH.appendChild(e.originalTarget.createTextNode("bindAdHandler = function (el) {};"));
	e.originalTarget.getElementsByTagName("body").item(0).appendChild(newBAH);
}


function do_geotrust(e) {
	if (prefBranch.getBoolPref('extensions.geotrust.enabled')) {
		var currentprofile = prefBranch.getCharPref("extensions.geotrust.profile");
		if (profile != currentprofile) {
			// update to new profile if changed
			profile = currentprofile;
			profilePrefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("extensions.geotrust." + profile + ".");
		}

		if (prefBranch.getBoolPref('extensions.geotrust.enabled-google') &&
				/^http:\/\/www\.google\..*\/search.*$/.test(e.originalTarget.location.href)) {
			do_geotrust_google(e);
		} else if (prefBranch.getBoolPref('extensions.geotrust.enabled-yahoo') &&
				/^http:\/\/([^\.]*\.)?search\.yahoo\.com\/search.*$/.test(e.originalTarget.location.href)) {
			do_geotrust_yahoo(e);
		} else if (prefBranch.getBoolPref('extensions.geotrust.enabled-msn') &&
				/^http:\/\/search\.([^\.]*\.)?msn\.[^\.]+\/results.aspx.*$/.test(e.originalTarget.location.href)) {
			do_geotrust_msn(e);
		}
	}
}

window.addEventListener("load",
	function() {
		var appcontent = window.document.getElementById("appcontent");
		if (appcontent) {
			if (!appcontent.greased_geotrust) {
				appcontent.greased_geotrust = true;

				updateGeotrustStatus();
				window.addEventListener("focus", updateGeotrustStatus, false);

				var menu = document.getElementById("contentAreaContextMenu");
				menu.addEventListener("popupshowing", geoContextPopupShowing, false);

				if (prefBranch.getBoolPref('extensions.geotrust.first_time')) {
					prefBranch.setBoolPref('extensions.geotrust.first_time', false);
					window.content.location.href = 'http://toolbar.trustwatch.com/software/extensions/firefox/search-ol/installed.html?ver=0.2.4';
				}

				appcontent.addEventListener("DOMContentLoaded", do_geotrust, false);
			}
		}
	}, false);
